Loading...
Searching...
No Matches
wayland::zwp_linux_dmabuf_v1_t Class Reference

factory for creating dmabuf-based wl_buffers More...

`#include <wayland-client-protocol-unstable.hpp>`

Inheritance diagram for wayland::zwp_linux_dmabuf_v1_t:
[legend]
Collaboration diagram for wayland::zwp_linux_dmabuf_v1_t:
[legend]

## Public Types

enum class | wrapper_type { standard , display , foreign , proxy_wrapper }

## Public Member Functions

zwp_linux_buffer_params_v1_t | create_params ()
| create a temporary object for buffer parameters
zwp_linux_dmabuf_feedback_v1_t | get_default_feedback ()
| get default feedback
bool | can_get_default_feedback () const
| Check whether the get_default_feedback function is available with the currently bound version of the protocol.
zwp_linux_dmabuf_feedback_v1_t | get_surface_feedback (surface_t const &surface)
| get feedback for a surface
bool | can_get_surface_feedback () const
| Check whether the get_surface_feedback function is available with the currently bound version of the protocol.
std::function< void(uint32_t)> & | on_format ()
| supported buffer format
std::function< void(uint32_t, uint32_t, uint32_t)> & | on_modifier ()
| supported buffer format modifier
uint32_t | get_id () const
| Get the id of a proxy object.
std::string | get_class () const
| Get the interface name (class) of a proxy object.
uint32_t | get_version () const
| Get the protocol object version of a proxy object.
wrapper_type | get_wrapper_type () const
| Get the type of a proxy object.
void | set_queue (event_queue_t queue)
| Assign a proxy to an event queue.
wl_proxy * | c_ptr () const
| Get a pointer to the underlying C struct.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
| operator bool () const
| Check whether this wrapper actually wraps an object.
bool | operator== (const proxy_t &right) const
| Check whether two wrappers refer to the same object.
bool | operator!= (const proxy_t &right) const
| Check whether two wrappers refer to different objects.
void | proxy_release ()
| Release the wrapped object (if any), making this an empty wrapper.

## Static Public Attributes

static constexpr std::uint32_t | create_params_since_version = 1
| Minimum protocol version required for the create_params function.
static constexpr std::uint32_t | get_default_feedback_since_version = 4
| Minimum protocol version required for the get_default_feedback function.
static constexpr std::uint32_t | get_surface_feedback_since_version = 4
| Minimum protocol version required for the get_surface_feedback function.

## Detailed Description

factory for creating dmabuf-based wl_buffers

Following the interfaces from: https://www.khronos.org/registry/egl/extensions/EXT/EGL_EXT_image_dma_buf_import.txt https://www.khronos.org/registry/EGL/extensions/EXT/EGL_EXT_image_dma_buf_import_modifiers.txt and the Linux DRM sub-system's AddFb2 ioctl.

This interface offers ways to create generic dmabuf-based wl_buffers.

Clients can use the get_surface_feedback request to get dmabuf feedback for a particular surface. If the client wants to retrieve feedback not tied to a surface, they can use the get_default_feedback request.

The following are required from clients:

- Clients must ensure that either all data in the dma-buf is coherent for all subsequent read access or that coherency is correctly handled by the underlying kernel-side dma-buf implementation.
- Don't make any more attachments after sending the buffer to the compositor. Making more attachments later increases the risk of the compositor not being able to use (re-import) an existing dmabuf-based wl_buffer.

The underlying graphics stack must ensure the following:

- The dmabuf file descriptors relayed to the server will stay valid for the whole lifetime of the wl_buffer. This means the server may at any time use those fds to import the dmabuf into any kernel sub-system that might accept it.

However, when the underlying graphics stack fails to deliver the promise, because of e.g. a device hot-unplug which raises internal errors, after the wl_buffer has been successfully created the compositor must not raise protocol errors to the client when dmabuf import later fails.

To create a wl_buffer from one or more dmabufs, a client creates a zwp_linux_dmabuf_params_v1 object with a zwp_linux_dmabuf_v1.create_params request. All planes required by the intended format are added with the 'add' request. Finally, a 'create' or 'create_immed' request is issued, which has the following outcome depending on the import success.

The 'create' request,

- on success, triggers a 'created' event which provides the final wl_buffer to the client.
- on failure, triggers a 'failed' event to convey that the server cannot use the dmabufs received from the client.

For the 'create_immed' request,

- on success, the server immediately imports the added dmabufs to create a wl_buffer. No event is sent from the server in this case.
- on failure, the server can choose to either:
  - terminate the client by raising a fatal error.
  - mark the wl_buffer as failed, and send a 'failed' event to the client. If the client uses a failed wl_buffer as an argument to any request, the behaviour is compositor implementation-defined.

For all DRM formats and unless specified in another protocol extension, pre-multiplied alpha is used for pixel values.

Warning! The protocol described in this file is experimental and backward incompatible changes may be made. Backward compatible changes may be added together with the corresponding interface version bump. Backward incompatible changes are done by bumping the version number in the protocol and interface names and resetting the interface version. Once the protocol is to be declared stable, the 'z' prefix and the version number in the protocol and interface names are removed and the interface version number is reset.

Definition at line 1519 of file wayland-client-protocol-unstable.hpp.

## Member Enumeration Documentation

## wrapper_type

enum class wayland::proxy_t::wrapper_type

strong inherited

Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator
standard | C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.
display | C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign

C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper | C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 116 of file wayland-client.hpp.

## Member Function Documentation

## c_ptr()

wl_proxy * wayland::proxy_t::c_ptr | ( |  | ) | const

inherited

Get a pointer to the underlying C struct.

Returns
  The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

## can_get_default_feedback()

bool zwp_linux_dmabuf_v1_t::can_get_default_feedback | ( |  | ) | const

Check whether the get_default_feedback function is available with the currently bound version of the protocol.

Definition at line 5230 of file wayland-client-protocol-unstable.cpp.

## can_get_surface_feedback()

bool zwp_linux_dmabuf_v1_t::can_get_surface_feedback | ( |  | ) | const

Check whether the get_surface_feedback function is available with the currently bound version of the protocol.

Definition at line 5242 of file wayland-client-protocol-unstable.cpp.

## create_params()

zwp_linux_buffer_params_v1_t zwp_linux_dmabuf_v1_t::create_params | ( |  | ) |

create a temporary object for buffer parameters

Returns
  the new temporary

This temporary object is used to collect multiple dmabuf handles into a single batch to create a wl_buffer. It can only be used once and should be destroyed after a 'created' or 'failed' event has been received.

Definition at line 5217 of file wayland-client-protocol-unstable.cpp.

## get_class()

std::string wayland::proxy_t::get_class | ( |  | ) | const

inherited

Get the interface name (class) of a proxy object.

Returns
  The interface name of the object associated with the proxy

## get_default_feedback()

zwp_linux_dmabuf_feedback_v1_t zwp_linux_dmabuf_v1_t::get_default_feedback | ( |  | ) |

get default feedback

This request creates a new wp_linux_dmabuf_feedback object not bound to a particular surface. This object will deliver feedback about dmabuf parameters to use if the client doesn't support per-surface feedback (see get_surface_feedback).

Definition at line 5224 of file wayland-client-protocol-unstable.cpp.

## get_id()

uint32_t wayland::proxy_t::get_id | ( |  | ) | const

inherited

Get the id of a proxy object.

Returns
  The id the object associated with the proxy

## get_surface_feedback()

zwp_linux_dmabuf_feedback_v1_t zwp_linux_dmabuf_v1_t::get_surface_feedback | ( | surface_t const & | surface | ) |

get feedback for a surface

Parameters

  surface |

This request creates a new wp_linux_dmabuf_feedback object for the specified wl_surface. This object will deliver feedback about dmabuf parameters to use for buffers attached to this surface.

If the surface is destroyed before the wp_linux_dmabuf_feedback object, the feedback object becomes inert.

Definition at line 5236 of file wayland-client-protocol-unstable.cpp.

## get_version()

uint32_t wayland::proxy_t::get_version | ( |  | ) | const

inherited

Get the protocol object version of a proxy object.

Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
  The protocol object version of the proxy or 0

## get_wrapper_type()

wrapper_type wayland::proxy_t::get_wrapper_type | ( |  | ) | const

inline inherited

Get the type of a proxy object.

Definition at line 302 of file wayland-client.hpp.

## on_format()

std::function< void(uint32_t)> & zwp_linux_dmabuf_v1_t::on_format | ( |  | ) |

supported buffer format

Parameters

  format | DRM_FORMAT code

This event advertises one buffer format that the server supports. All the supported formats are advertised once when the client binds to this interface. A roundtrip after binding guarantees that the client has received all supported formats.

For the definition of the format codes, see the zwp_linux_buffer_params_v1::create request.

Starting version 4, the format event is deprecated and must not be sent by compositors. Instead, use get_default_feedback or get_surface_feedback.

Definition at line 5248 of file wayland-client-protocol-unstable.cpp.

## on_modifier()

std::function< void(uint32_t, uint32_t, uint32_t)> & zwp_linux_dmabuf_v1_t::on_modifier | ( |  | ) |

supported buffer format modifier

Parameters

  format | DRM_FORMAT code
  modifier_hi | high 32 bits of layout modifier
  modifier_lo | low 32 bits of layout modifier

This event advertises the formats that the server supports, along with the modifiers supported for each format. All the supported modifiers for all the supported formats are advertised once when the client binds to this interface. A roundtrip after binding guarantees that the client has received all supported format-modifier pairs.

For legacy support, DRM_FORMAT_MOD_INVALID (that is, modifier_hi == 0x00ffffff and modifier_lo == 0xffffffff) is allowed in this event. It indicates that the server can support the format with an implicit modifier. When a plane has DRM_FORMAT_MOD_INVALID as its modifier, it is as if no explicit modifier is specified. The effective modifier will be derived from the dmabuf.

A compositor that sends valid modifiers and DRM_FORMAT_MOD_INVALID for a given format supports both explicit modifiers and implicit modifiers.

For the definition of the format and modifier codes, see the zwp_linux_buffer_params_v1::create and zwp_linux_buffer_params_v1::add requests.

Starting version 4, the modifier event is deprecated and must not be sent by compositors. Instead, use get_default_feedback or get_surface_feedback.

Definition at line 5253 of file wayland-client-protocol-unstable.cpp.

## operator bool()

wayland::proxy_t::operator bool | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## operator!=()

bool wayland::proxy_t::operator!= | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to different objects.

## operator==()

bool wayland::proxy_t::operator== | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to the same object.

## proxy_has_object()

bool wayland::proxy_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## proxy_release()

void wayland::proxy_t::proxy_release | ( |  | ) |

inherited

Release the wrapped object (if any), making this an empty wrapper.

Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
  foreign_display.cpp.

## set_queue()

void wayland::proxy_t::set_queue | ( | event_queue_t | queue | ) |

inherited

Assign a proxy to an event queue.

Parameters

  queue | The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
  proxy_wrapper.cpp.

## Member Data Documentation

## create_params_since_version

constexpr std::uint32_t wayland::zwp_linux_dmabuf_v1_t::create_params_since_version = 1

static constexpr

Minimum protocol version required for the create_params function.

Definition at line 1556 of file wayland-client-protocol-unstable.hpp.

## get_default_feedback_since_version

constexpr std::uint32_t wayland::zwp_linux_dmabuf_v1_t::get_default_feedback_since_version = 4

static constexpr

Minimum protocol version required for the get_default_feedback function.

Definition at line 1570 of file wayland-client-protocol-unstable.hpp.

## get_surface_feedback_since_version

constexpr std::uint32_t wayland::zwp_linux_dmabuf_v1_t::get_surface_feedback_since_version = 4

static constexpr

Minimum protocol version required for the get_surface_feedback function.

Definition at line 1592 of file wayland-client-protocol-unstable.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.cpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp